#region usings
using System;
using System.ComponentModel.Composition;

using VVVV.PluginInterfaces.V1;
using VVVV.PluginInterfaces.V2;
using VVVV.Utils.VColor;
using VVVV.Utils.VMath;

using VVVV.Core.Logging;
#endregion usings

namespace VVVV.Nodes
{
	public class MyType
	{
		
	}
	
	#region PluginInfo
	[PluginInfo(Name = "MyTypeCons", Category = "Value", Help = "Basic template with one value in/out", Tags = "")]
	#endregion PluginInfo
	public class ValueDynamicConsNode : IPluginEvaluate
	{
		#region fields & pins
		[Input("Input", IsPinGroup=true)]
		public ISpread<ISpread<MyType>> FInput;

		[Output("Input")]
		public ISpread<ISpread<MyType>> FOutput;

		[Import()]
		public ILogger FLogger;
		#endregion fields & pins

		//called when data for any output pin is requested
		public void Evaluate(int SpreadMax)
		{
			FOutput.AssignFrom(FInput);
		}
	}
	
	[PluginInfo(Name = "TypeSource", Category = "Value", Help = "Basic template with one value in/out", Tags = "")]
	public class TypeSourceNode : IPluginEvaluate
	{
		[Output("Input", IsPinGroup=true)]
		public Pin<MyType> input;

		//called when data for any output pin is requested
		public void Evaluate(int SpreadMax)
		{
		}
	}
	
	[PluginInfo(Name = "TypeSink", Category = "Value", Help = "Basic template with one value in/out", Tags = "")]
	public class TypeSinkNode : IPluginEvaluate
	{
		[Input("Input", IsPinGroup=true)]
		public Pin<MyType> input;
		
		[Output("Connected", IsPinGroup=true)]
		public ISpread<bool> connected;

		//called when data for any output pin is requested
		public void Evaluate(int SpreadMax)
		{
			connected[0] = input.IsConnected;
		}
	}
}
